#ifndef KONQBOOKMARKMANAGER_H
#define KONQBOOKMARKMANAGER_H

#include <kbookmarkmanager.h>
#include <kstandarddirs.h>

#include <stdlib.h>
#include <qfile.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>


class KonqBookmarkManager
{
 public:
  static KBookmarkManager * self() {
    if ( !s_bookmarkManager )
      {
	internationalBookmarks();
	QString bookmarksFile = locateLocal("data", QString::fromLatin1("konqueror/bookmarks.xml"));
	s_bookmarkManager = KBookmarkManager::managerForFile( bookmarksFile );
      }
    return s_bookmarkManager;
  }
  static void internationalBookmarks()
  {
    QString newBookmarksFile = locateLocal("data", QString::fromLatin1("konqueror/bookmarks.xml"));
    QString copyBookmarksFile;
    switch(KStandardDirs::mandrake_distro_version())
      {
      case KStandardDirs::DOWNLOAD:
	copyBookmarksFile = QString("/usr/share/mdk/kde/bookmarks/bookmarks-download-%1.xml" );
	break;
      case KStandardDirs::POWERPACK:
	copyBookmarksFile = QString("/usr/share/mdk/kde/bookmarks/bookmarks-powerpack-%1.xml" );
	break;
      case KStandardDirs::DISCOVERY:
	copyBookmarksFile = QString("/usr/share/mdk/kde/bookmarks/bookmarks-discovery-%1.xml" );
	break;
      case KStandardDirs::POWERPACKPLUS:
	copyBookmarksFile = QString("/usr/share/mdk/kde/bookmarks/bookmarks-powerpackplus-%1.xml" );
	break;
      }
    if ( !QFile( newBookmarksFile ).exists() )
      {
	QStringList langList = QStringList::split(":",QString::fromLocal8Bit(getenv("LANGUAGE")));
	bool languageFound = false;
	for ( QStringList::Iterator it = langList.begin(); it != langList.end(); ++it )
	  {
	    QString tmpFile = copyBookmarksFile.arg(*it);
	    if( QFile::exists(tmpFile))
	      {
		copyBookmarksFile = tmpFile;
		languageFound = true;
		break;
	      }
	  }
	if ( !languageFound )
	  {
	    //default
	    switch(KStandardDirs::mandrake_distro_version())
	      {
	      case KStandardDirs::DOWNLOAD:
		copyBookmarksFile = QString("/usr/share/mdk/kde/bookmarks/bookmarks-download.xml" );
		break;
	      case KStandardDirs::POWERPACK:
		copyBookmarksFile = QString("/usr/share/mdk/kde/bookmarks/bookmarks-powerpack.xml" );
		break;
	      case KStandardDirs::DISCOVERY:
		copyBookmarksFile = QString("/usr/share/mdk/kde/bookmarks/bookmarks-discovery.xml" );
		break;
	      case KStandardDirs::POWERPACKPLUS:
		copyBookmarksFile = QString("/usr/share/mdk/kde/bookmarks/bookmarks-powerpackplus.xml" );
		break;
	      }
	    if( !QFile::exists(copyBookmarksFile))
	      copyBookmarksFile="";
	  }
	if ( !copyBookmarksFile.isEmpty() )
	  {
	    QCString cmd = "cp ";
	    cmd += QFile::encodeName( copyBookmarksFile );
	    cmd += " ";
	    cmd += QFile::encodeName( newBookmarksFile );
	    system( cmd );
	  }
      }
  }

 private:
  static KBookmarkManager *s_bookmarkManager;
};

#endif
